
	global _crc_type_1
	global _crc_type_R ; only used by RMNC-KISS
	global _checksum
	global _parity
	global _xor

	section .inthand ; (.fastext) silly really, on a 150 cps channel, but...
	align  1

_crc_type_1       ; word (word cc_E, word iv_D, word poly, byte *p);
	pshm z
	tsz           ; poly in 6,z and p in 8,z
	ldx  8,z      ; p in X
	              ; iv in D, seed of CRC, already in position, also cc in E
L1
	eorb 0,x      ; crc ^= *p++
	aix  #+1

	REPT 8        ; 6 bytes, 8 times, 48 total
	lsrd
	bcc  * + 4    ; skip eord if no carry
	eord 6,z      ; poly
	ENDR

	aie  #-1      ; while (--cc)
	bne  L1

	pulm z
	rts

_crc_type_R       ; word (word cc_E, word iv_D, word poly, byte *p)
	pshm z
	tsz
	ldx  8,z      ; p
L9
	stab 8,z      ; use 'p' as scratch for old crc
	tab
	clra
	comd
	eorb 0,x      ; copy of irpt above, upto ENDR
	aix  #+1

	REPT 8
	lsrd
	bcc  * + 4    ; skip eord if no carry
	eord 6,z      ; poly
	ENDR

	eora 8,z      ; one round of crc done.

	aie  #-1
	bne  L9

	pulm z
	rts

_checksum         ;  Simple bytewide sum, 16-bit result

	xgex          ; address
	xgdy          ; bytecount
	clrd          ; accu
L2
	addb 0,x
	adca # 0
	aix  #+1
	aiy  #-1
	bne  L2

	rts

unused MACRO

_xor              ;  Simple bytewide xor

	xgex          ; address
	xgdy          ; bytecount
	clrd          ; accu
L2
	eorb 0,x
	aix  #+1
	aiy  #-1
	bne  L2

	rts

_parity           ;  1-bits in given area, 16-bit result

	xgex          ; address
	xgdy          ; bytecount
	clre
L3
	ldab 0,x
	lsrb          ; assume MSbit 0 more often than 1
L4
	adce # 0      ; nasty to have doubleword op here XXX
	lsrb
	bne  L4       ; still 1-bits in there
	adce # 0      ; not forgetting the last 1-bit

	aix  #+1
	aiy  #-1
	bne  L3

	ted
	rts

_parity           ; 1-bits in given area, 8-bit result

	xgex          ; address
	xgdy          ; bytecount
	clrb
L3
	ldaa 0,x
	lsra          ; assume MSbit 0 more often than 1
L4
	adcb # 0
	lsra
	bne  L4       ; still 1-bits in there
	adcb # 0      ; not forgetting the last 1-bit

	aix  #+1
	aiy  #-1
	bne  L3

	rts           ; A already clear

	ENDM

	end

