
;-----------------------------------------------------------
	section .text2
	align 1

;-----------------------------------------------------------
; XXX
; XXX  fncall(arg, pointer_to_text_segment)
; XXX
; XXX  NOT INTO RAM OR SEGMENT 2

	global _fncall
	global _tablecall

_tablecall            ; anytype tablecall(arg, index, table);

	asld              ; index to word offset
	tsx
	addd 4,x          ; table
	xgdx
	ldd  0,x          ; table[index]
	bne  _fncall
	clre              ; return FALSE or NULL or 0 or 0L
	rts

_fncall               ; anytype fncall(arg, fn)
	xgdx
	jmp  text_start,x ; one argument, still in E

;-----------------------------------------------------------
	global _REM
_REM              ; word REM(word *num_inout, word divisor)
	xgey          ; inout
	xgdx
	ldd  0,y      ; D = *inout
	idiv          ; D / IX to IX, rem D
	stx  0,y      ; *inout = quot
	rts

	global _DIV
_DIV              ; word DIV(word_dividend_E, word_divisor_D, &word_remainder)

	xgdx
	ted
	idiv          ; D / IX to IX, remainder to D
	xgdx
	tsy
	ldy  4,y      ; &rem wanted ?
	beq  L8
	stx  0,y
L8
	rts

	global _EDIV
_EDIV             ; word EDIV(long_dividend_ED, word_divisor, &word_remainder)

	tsy
	ldx  4,y      ; divisor
	ediv          ; E:D / IX to IX, remainder to D
	xgdx          ; result to D, remainder to IX

	ldy  6,y      ; pointer to remainder
	beq  L9       ; could be NULL
	stx  0,y      ; store remainder
L9
	rts

	global _EMUL        ; dword EMUL(word, word)
_EMUL
	emul                ; ED = E * D
	rts

	global _FMULS       ; dword FMULS(word, word)
_FMULS
	fmuls
	rts

	global _EDIVx       ; dword EDIVx(dword dvdnd, word divsr, word *prem)
_EDIVx

	xgde                ; swap dividend words, D is HIW(dividend), E LOW()
	tsx
	ldx  4,x            ; get divisor
	idiv                ; D / IX to IX, remainder to D
	txy                 ; save HIW(result)
	xgde                ; E is 1st remainder and D LOW(dividend)
	tsx
	ldx  4,x            ; get divisor again
	ediv                ; ED / IX to IX, remainder to D
	xgdx                ; D is LOW(result), IX is remainder
	xgey                ; and the saved HIW(result) in final position
	tsy
	ldy  6,y            ; get prem
	beq  L1             ; if prem is NULL
	stx  0,y            ; else store remainder
L1
	rts

	global _EMULx
_EMULx            ; long EMULx(long ED, word)  ML * X = M * X * 0x10000 + L * X

	tsx           ; use IX for stacked arg

	xgdy          ; save L in Y for a while
	ldd  4,x      ; get X from stack
	emul          ; M * X to E:D  ---  fits in D (overflows ignored XXX)

	xgdy          ; save M * X and get L back to D

	lde  4,x      ; get X from stack, again
	emul          ; X * L to E:D --- LSWord is ready in D

	xgdy          ; save LSWord, get M * X to D
	ade           ; MSWord is ready in E. result E:Y

	xgdy          ; fix proper return in E:D
	rts

	global _muldiv
_muldiv           ; word muldiv(word value_e, word multiplier_d, word divisor)

	tsx
	ldx  4,x      ; divisor
	emul          ; E:D = E * D
	ediv          ; IX = E:D / IX, remainder to D
	xgdx          ; result to D, remainder to IX
	rts

;-----------------------------------------------------------
	global _LSRx

_LSRx              ; void LSRx(long *E, word numbits_D) logical shift right

	tstd
	beq  LSRx_out  ; shifting 0 bits is quick

	xgey           ; long at 0,Y
	xgdx           ; numbits in X

	lde  0,y
	ldd  2,y

	; XXX place to shortcut shift by 16 - not used yet

	cpx  # 8       ; shortcut a byte ?
	bcs  LSRx_loop

	clra
	ldab 0,y
	tde
	ldd  1,y

	aix  #-8
	beq  LSRx_done ; exactly 8, nothing more to do

LSRx_loop
	lsre
	rord           ; shifted one bit
	aix  #-1
	bne  LSRx_loop ; more ?

LSRx_done
	ste  0,y
	std  2,y

LSRx_out
	rts           ; long return in E:D


	global _ASLx

_ASLx             ; void ASLx(long *E, word numbits_D) shift left

	tstd
	beq  ASLx_out ; nothing to do

	xgey          ; long at 0,Y
	xgdx          ; numbits in X

	lde  0,y
	ldd  2,y

	; XXX place to shortcut shift by 16 - not used yet
	; XXX place to shortcut shift by 8 - not used yet

ASLx_loop
	asld
	role          ; shifted one bit
	aix  #-1      ; more ?
	bne  ASLx_loop

ASLx_done
	ste  0,y
	std  2,y

ASLx_out
	rts           ; long return in E:D

;-----------------------------------------------------------
	global _RRC_byte, _RLC_byte, _ASL_word, _LSR_word

_RRC_byte
	ted          ; implicit clear A
	rore         ; old LSbit to carry
	rorb         ; push carry to B from left
	rts

_RLC_byte
	ted          ; implicit clear A
	addb #80h    ; push the old MSbit to carry
	rolb         ; push carry to B from right
	rts

shift_right
	lsre
_LSR_word
	subb # 1
	bcc  shift_right
	ted
	rts

shift_left
	asle
_ASL_word
	subb # 1
	bcc  shift_left
	ted
	rts

;-----------------------------------------------------------
	global _read_PORTE, _read_PORTF, _read_PORTQS, _read_PACTL, _read_RSSI
	global _read_AN7_batt
	global _read_AN
	global _peekw
	global _read_PWM, _write_PWMB

_read_PWM
	lde  # 0F926h            ; PWMA MSByte, PWMB LSByte
	bra  peekw_seg_FF

_read_PORTE
	lde  # 0FA10h            ; PORTE as a word
	bra  peekw_seg_FF

_read_PORTF
	lde  # 0FA18h            ; PORTF as a word
	bra  peekw_seg_FF

_read_PORTQS
	lde  # 0FC14h            ; PORTQS as a word
	bra  peekw_seg_FF

_read_PACTL
	lde  # 0F90Ch
	bra  peekw_seg_FF

_read_RSSI
	lde  # 0F712h            ; RJURR1
	bra  peekw_seg_FF

_read_AN7_batt
	xgex                 ; put scale into IX
	lde  # 7             ; AN7 ...
	bsr _read_AN         ; ... into D and scale gets back into E
	emul                 ; ED = E * D
	ted                  ; D = decivolts
	rts

_read_AN
	asle                 ; register = wordify index and add LJURR0
	adde # 0F730h        ; left justified unsigned result reg 0

peekw_seg_FF
	ldab # 0FFh

_peekw                   ; word peekw(word offset_E, word segment_D)
	xgex
	pshm k
	tbxk
	ldd  0,x
	pulm k
	rts

_write_PWMB
	pshm k
	ldab # 0FFh
	tbek
	ted
	stab 0F927h          ; PWMB
	pulm k
	rts

;-----------------------------------------------------------

PORTC  equ 0FA41h
PORTGP equ 0F907h
PORTQS equ 0FC15h

rdpin	MACRO fn, offset, bit
	global fn
fn
	ldx  # 0           ; wrap-access
	brset offset,x, # 1<<bit, rdpin_1
	clrd
	rts
	ENDM

rdpin_1
	ldd  # 1
	rts

	; asy input pins

	rdpin _RTS1_pin, PORTQS, 6
	rdpin _DTR1_pin, PORTQS, 5
	rdpin _DTR2_pin, PORTQS, 4
	rdpin _RTS2_pin, PORTGP, 1

;-----------------------------------------------------------

wrpin	MACRO fn, lab, offset, bit
	global fn
fn
	ldx  # 0           ; wrap-access
	tste
	bne  lab
	bclr offset,x, # 1<<bit
	rts
lab
	bset offset,x, # 1<<bit
	rts
	ENDM

	; asy output pins

	wrpin _DSR1_pin, L1003, PORTGP, 4
	wrpin _CTS2_pin, L1004, PORTGP, 3
	wrpin _CTS1_pin, L1005, PORTGP, 2
	wrpin _DCD2_pin, L1006, PORTGP, 7
	wrpin _DCD1_pin, L1007, PORTGP, 6

	; yellow leds, top to bottom

	wrpin _tx_led,      L1000, PORTC, 0
	wrpin _afsk_tx_led, L1001, PORTC, 1
	wrpin _afsk_rx_led, L1002, PORTC, 2

	global _green_leds

_green_leds
	ldx  # 0       ; wrap access
	lsre
	bcs  L61
	bclr PORTC,x, # 08h
	bra  L62
L61
	bset PORTC,x, # 08h
L62
	lsre
	bcs  L63
	bclr PORTC,x, # 10h
	bra  L64
L63
	bset PORTC,x, # 10h
L64
	lsre
	bcs  L65
	bclr PORTC,x, # 20h
	bra  L66
L65
	bset PORTC,x, # 20h
L66
	rts

;-----------------------------------------------------------
	global _repack_bcd_to_binary

_repack_bcd_to_binary

	xgex            ; buffer
	xgdy            ; byte count
L90
	ldaa 0,x        ; bcd              ---- 23--     ---- 99--
	tab             ;                  ???? 2323     ???? 9999
	andd # 0FF0h    ; ones and tens    ???? 0320     ???? 0990
	tde             ; save in E MSByte 0320 0320     0990 0990
	lsrb            ; nice             0320 0310     0990 0948
	tba             ;  shortcut        0320 1010     0990 4848
	lsrb            ;  for /= 16       0320 1008     0990 4824
	lsrb            ;  and *= 10       0320 1004     0990 4812
	aba             ; tens in binary   0320 1404     0990 5A12
	ade             ; merge with ones  1724 1404     63A2 5A12
	ted             ;                  1724 1724     63A2 63A2
	staa 0,x        ; binary           ---- 17--     ---- 63--

	aix  #+1
	aiy  #-1
	bne  L90
	rts


;-----------------------------------------------------------
	global _ld_word_intel, _ld_dword_intel
	global _ld_short_intel, _ld_long_intel

_ld_word_intel
_ld_short_intel

	xgex
	ldd  0,x
	xgab
	rts

_ld_dword_intel
_ld_long_intel

	xgex
	ldd  2,x
	xgab
	tde
	ldd  0,x
	xgab
	rts

;-----------------------------------------------------------
;  void SCALExx(long *in_out_E, long *factor_D);

	global _SCALE32, _SCALE24, _SCALE16
	global _SCALE32_signed


_SCALE32_signed

	xgex          ; argh, quite a few exchanges here
	tst  0,x      ; is it negative ?
	xgex
	bpl  _SCALE32 ; positive, skip dancing
	xgex
	bsr  neg
	xgex
	bsr  _SCALE32 ; in_out_ returned in IX
neg
	comw 0,x
	comw 2,x
	incw 2,x
	bne  L71
	incw 0,x
L71
	rts


_SCALE32

	pshm z
	ais  #-8      ; 4 words of scratch XXX return all 64 bits to caller
	tsz
	bsr  mullit

	lde  0,z      ; 32 top bits of result
	ldd  2,z
	bra  scale_ret

_SCALE24

	pshm z
	ais  #-8
	tsz
	bsr  mullit

	lde  1,z      ; drop 24 bits from result
	ldd  3,z
	bra  scale_ret

_SCALE16

	pshm z
	ais  #-8
	tsz
	bsr  mullit

	lde  2,z      ; 32 middle bits of result
	ldd  4,z
scale_ret
	ste  0,x      ; in_out 1st argument
	std  2,x

	ais  #+8
	pulm z
	rts

mullit

	xgex          ; long ab at X
	xgdy          ; long cd at Y

	ldd  2,y
	lde  2,x
	emul          ; bd low 32 bits
	std  6,z
	ste  4,z

	ldd  0,y
	lde  0,x
	emul          ; ac high 32 bits
	std  2,z
	ste  0,z

	ldd  2,y
	lde  0,x
	emul          ; ad in the middle
	bsr  addit

	ldd  0,y
	lde  2,x
	emul          ; bc in the middle

	; bsr  addit -  fall thru insted.

addit

	addd 4,z
	std  4,z
	adce 2,z
	ste  2,z
	bcc  L7
	incw 0,z
L7
	rts


;-----------------------------------------------------------
	global _atol_signed   ; void atol_signed(long *result, char *str);

_atol_signed

	pshm  z
	ais   #-4
	tsz           ; Z to scratch

	xgey          ; Y to long
	xgdx          ; X to string

	clrw  2,y
	clrw  0,y
	clrw  0,z     ; scratch digit, MSByte always 0
L10
	ldab  0,x
	cmpb  # ' '
	bne   L11
	aix   #+1
	bra   L10     ; more blankskipping
L11
	cmpb  # '-'
	bne   L12
	aix   #+1
L12
	std   2,z     ; scratch sign
L13
	ldab  0,x
	subb  # '0'
	bcs   L14     ; below 0
	cmpb  # 9
	bhi   L14     ; above 9

	stab  1,z     ; 0 ... 9 to add after *= 10

	ldd   2,y
	lde   0,y
	asld
	role
	asld
	role
	addd  2,y
	adce  0,y     ; 5 times
	asld
	role          ; 10 times
	addd  0,z
	adce  # 0
	std   2,y
	ste   0,y

	aix   #+1
	bra   L13     ; more digits
L14
	ldd   2,z     ; was it negative ?
	cmpb  # '-'
	bne   L15
	clrd
	clre
	subd  2,y
	sbce  0,y
	std   2,y
	ste   0,y
L15
	ais   #+4
	pulm  z
	rts


;-----------------------------------------------------------

	global _sscan_02u   ; only arg - pointer in E
	global _sscan_03u

_sscan_02u

	xgex

	ldab 0,x
	subb # '0'
	ldaa # 10
	mul
	addb 1,x
	subb # '0'
	rts

_sscan_03u

	xgex

	ldab 0,x
	subb # '0'
	ldaa # 100
	mul
	tde
	ldab 1,x
	subb # '0'
	ldaa # 10
	mul
	ade
	ldab 2,x
	subb # '0'
	clra
	ade
	ted
	rts

	global _sscan_num   ; pointer and length
	global _sscan_hex

_sscan_num

	xgex      ; byte *
	xgdy      ; word len
	clre
sn1
	ted
	asle
	asle
	ade
	asle       ; *= 10
	ldab 0,x
	subb # '0'
	cmpb # 9
	bhi  sn2   ; not an integer number
	clra
	ade
	aix  #+1
	aiy  #-1
	bne  sn1   ; loop --len
	ted
	rts

sn2
	ldd  # -1
	rts

_sscan_hex

	xgex      ; byte *
	xgdy      ; word len
	clre
sn3
	ldab 0,x
	subb # '0'
	cmpb # 9
	bls  sn4    ; digit.
	andb # ~20h ; upper/lower
	subb # 17   ; trickstery
	cmpb # 5
	bhi  sn2    ; not A...F or a...f or digit
	addb # 10
sn4
	asle
	asle
	asle
	asle       ; <<= 4
	clra
	ade
	aix  #+1
	aiy  #-1
	bne  sn3   ; loop --len
	ted
	rts

;-----------------------------------------------------------

	global _sprint_02u   ; 1st arg - pointer in E
	global _sprint_03u   ; 2nd arg - number in D
	global _sprint_04u   ; return modified pointer.
	global _sprint_05u
	global _sprint_02X

_sprint_02u
	ldy  # 1             ; 1 divide needed
	bsr  sprint_nnn
	aiy  # 2             ; point one past buffer
	bra  sprint_ret

_sprint_03u
	ldy  # 2
	bsr  sprint_nnn
	aiy  # 3
	bra  sprint_ret

_sprint_04u
	ldy  # 3
	bsr  sprint_nnn
	aiy  # 4
	bra  sprint_ret

_sprint_05u
	ldy  # 4
	bsr  sprint_nnn
	aiy  # 5
	; bra  sprint_ret
sprint_ret
	xgdy                 ; return one past buffer
	rts

sprint_nnn
	xgey                 ; buffer into iy, divide count into E
	aey                  ; point to LSdigit

sprint_not_last
	ldx  # 10
	idiv                 ; D / IX to IX, remainder in B (A 0)
	addb # '0'
	stab 0,y
	aiy  #-1             ; next MSdigit
	xgdx                 ; prepare for next digit
	sube # 1
	bne  sprint_not_last

	addb # '0'           ; final digit
	stab 0,y
	rts                  ; iy back over buffer


_sprint_02X
	xgey                    ; iy        (byte *p,
	clra
	tde                     ; b and e    byte num)
	lsre
	lsre
	lsre
	lsre                    ; MSnybble
	andb # 0Fh              ; LSnybble
	ldx  # _hex_characters
	ldaa e,x
	staa 0,y                ; p[0]
	abx
	ldaa 0,x
	staa 1,y                ; p[1]
	aiy  #+2
	xgdy
	rts                     ; return (p + 2)

;-----------------------------------------------------------
	global _sprint_i, _sprint_u

_sprint_i             ; byte *sprint_i(byte *p, short i)

	tstd
	bge  _sprint_u    ; if zero or positive
	negd              ; u = -i

	xgey              ; p in IY
	xgde              ; u in E
	ldab # '-'
	stab 0,y          ; *p++ = '-'
	aiy  #+1
	xgde              ; u in D
	xgey              ; p in E, ok to fall thru to ...

_sprint_u             ; byte *sprint_u(byte *p, word u)

	xgey              ; p in IY
	bsr  sprint_u
	clr  0,y          ; convenience, terminate \0
	xgdy              ; return modified p
	rts

sprint_u
	cpd  # 10         ; only one digit left ?
	blo  sprint_u_last
	ldx  # 10
	idiv              ; D / IX to IX, remainder to D
	pshm d            ; this digit
	xgdx              ; do upper digits
	bsr  sprint_u
	pulm d            ; this digit back

sprint_u_last
	addb # '0'
	stab 0,y          ; *p++ = mod + '0'
	aiy  #+1
	rts

;-----------------------------------------------------------
decades
	dc.l 1000000000
	dc.l 100000000
	dc.l 10000000
	dc.l 1000000
	dc.l 100000
	dc.l 10000
	dc.l 1000
	dc.l 100
	dc.l 10
decadend

	global _sprint_010Lu

_sprint_010Lu

	pshm k,z

	xgey            ; dst in IY
	xgdz            ; &number in IZ

	tpd
	tbxk            ; XK:IX for the constants
	ldx  # decades

	lde  0,z
	ldd  2,z        ; number in ED
L16
	ldz  # '0' - 1  ; adjusted for one increment too many
L17
	aiz  #+1        ; next digit - no danger of ZK wrap
	subd 2,x
	sbce 0,x
	bcc  L17        ; while at or over the decade

	addd 2,x
	adce 0,x        ; undo last sub

	xgdz
	stab 0,y        ; another digit
	aiy  #+1        ; bump dst pointer
	xgdz
	aix  #+4        ; next decade
	cpx  # decadend
	bcs  L16        ; while they last

	addb # '0'      ; finally the ones
	stab 0,y
	clr  1,y        ; "C" terminator \0

	pulm k,z
	rts

;-----------------------------------------------------------
	                               ; extern long gps_altitude;
	global _sted_gps_altitude      ; void (long ED)

_sted_gps_altitude
	sted  _gps_altitude
	rts

;-----------------------------------------------------------
	global _link_list_append

_link_list_append  ; void l_l_a(struct **pp_E, struct *D);

	xgex           ; pp
L42
	txy            ; prev pp
	ldx  0,x       ; pp = (*pp)->next --- 'next' must be 1st in struct
	bne  L42       ; do while
	std  0,y       ; append at prev pp
	rts

;	global _link_list_use
;
;_link_list_use    ; void l_l_u(space_size, struct_size, space, &head)
;	tsy
;	ldx  4,y       ; space
;	ldy  6,y       ; &head
;	pshm y
;	ldy  0,y       ; head previously
;	bra  L44       ; start loop
;L43
;	sty  0,x       ; struct.next = head
;	txy            ; head = space
;	adx            ; space += struct_size
;L44
;	sde            ; space_size -= struct_size
;	bcc  L43       ; while more space
;
;	pulm x
;	sty  0,x       ; head updated
;	rts
;
;-----------------------------------------------------------

	global _half_c_to_fahrenheit

_half_c_to_fahrenheit
	ldd  # 29491       ; == 0.9 == 0.5 * 9/5
	fmuls
	adce # 32          ; rounding too
	ted
	rts                ; really enjoyable exercises, these.

;-----------------------------------------------------------

	global _length_without_crlf

_length_without_crlf     ; word l_w_crlf(byte *start_E, byte *end_D)

	xgde                 ; start_D, end_E
	sde                  ; E has length
	xgdx                 ; IX has start

	bra  L31
L30
	ldab e,x             ; start[length]
	cmpb # 10
	beq  L31

	cmpb # 13
	beq  L31

	cmpb # ' '
	bne  L32
L31
	sube # 1
	bcc  L30             ; while (--length >= 0)
L32
	adde # 1             ; undo last --
	ted
	rts 

;-----------------------------------------------------------

	global _bump_counter

_bump_counter     ; word bump_counter(max, &counter);

	xgdx          ; X &counter
	ldd  0,x
	addd # 1      ; D new count
	sde
	bcc  L100     ; still <= max ?
	clrd          ; wrap
L100
	std  0,x      ; remember
	rts

;-----------------------------------------------------------
;-----------------------------------------------------------
	end
