
; N81 software uart, tx side
; OC5 times and outputs databits
; IC4/OC5 PGP7 DCDB  cpu/130  U2/19 -->o-- /24 --- D25/12 DCD2
; no hardware changes needed.

	include regs.inc

IC4_OC5_V equ  90h
I4O5      equ  04h  ; PACTL selects which it is, 0=OC5 1=IC4

I4O5F     equ  80h  ; TFLG1 and TMSK1. PGP7
OC5set    equ  80h  ; TCTL1
OC5olvl   equ  40h

	;------------------------------------------------------------
	section .bankf
	align 1

bittime    ds.w 1
shifter    ds.w 1
remove     ds.w 1
insert     ds.w 1

	section .bss

buffer     ds.b 512
bufend

	;------------------------------------------------------------
	section .inthand
	align 1

IC4_OC5_int

	pshm d,k
	ldab # FF
	tbek

	lsrw shifter
	bcs  one               ; onebit (maybe stopbit)
	bne  zero              ; zerobit (not yet stopbit)

	ldd  remove
	cpd  insert
	beq  idle
	pshm z                 ; ZK always RAM segment
	xgdz
	ldab 0,z               ; next byte
	aiz  #+1
	cpz  # bufend
	blo  L0
	ldz  # buffer
L0
	stz  remove
	pulm z
	ldaa # 1               ; marker for stopbit
	std  shifter           ; fall thru to startbit
zero
	ldd  bittime
	addd TI4O5
	std  TI4O5
	bclr TFLG1, # I4O5F
	bclr TCTL1, # OC5olvl  ; 10 = clear output line when compare
	pulm d,k
	rti
one
	ldd  bittime
	addd TI4O5
	std  TI4O5
	bclr TFLG1, # I4O5F
	bset TCTL1, # OC5olvl  ; 11 = set output line when compare
	pulm d,k
	rti
idle
	bclr TMSK1, # I4O5F    ; mask OC5 interrupt
	pulm d,k
	rti

	;------------------------------------------------------------
	section .text
	align 1

	global _bbtxd_putc

_bbtxd_putc

	pshm k,ccr
	ldab # FF
	tbek

	ted                     ; byte to putc in B
	ldx  insert
	stab 0,x
	aix  #+1
	cpx  # bufend
	blo  L1
	ldx  # buffer
L1
	orp  # 000E0h
	stx  insert

	brset TMSK1, # I4O5F, L2 ; already

	ldd  bittime
	addd TCNT
	std  TI4O5
	bclr TFLG1, # I4O5F
	bset TMSK1, # I4O5F     ; unmask OC5 interrupt
L2
	pulm k,ccr
	rts

	global _bbtxd_init

_bbtxd_init

	jsr  soft_uart_bittime  ; baud to ticks, in/out in E

	pshm k,ccr
	orp  # 000E0h

	ldd  # IC4_OC5_int
	std  IC4_OC5_V

	ldab # FF
	tbek                   ; switch EXT

	ste  bittime
	clrw shifter

	ldd  # buffer
	std  insert
	std  remove

	bset DDRGP, # I4O5F    ; output
	bset PORTGP, # I4O5F   ; idle

	bclr PACTL, # I4O5     ; select OC5, bit clear
	bclr TMSK1, # I4O5F    ; mask OC5 interrupt

	; 1x = set output to x

	bset TCTL1, # OC5set+OC5olvl

	pulm k,ccr             ; restore IPL
	rts

