
typedef unsigned short word;
typedef unsigned long dword;
#define EMUL(a,b) ((a) * (b))
#define HIWORD(x) ((x) >> 16)


/*
 *  +5.1Vdc
 *  0...+85 celsius
 *  Vout = Vs (0.009 P - 0.095) +- error
 *  P = Vout / Vs / 0.009 + 0.095 / 0.009 [kPa]
 *  return 0.1 hPa
 *  XXX loss of precision if no analog prescaling.
 */
word
mpx4115a_pressure(word ana)
{
	dword x = EMUL(11111L, ana) + 69176889L;

	return (HIWORD(x));
}

main()
{
	word ana;
	word noise = 0x7F;

	for (ana = 0xC900; ana < 0xD300; ++ana) {
		printf("0x%04X %5d\n", ana & ~noise, mpx4115a_pressure(ana & ~noise));
	}
}

