
/* ds1621/1721/1631/1731/... */

#include "standard.h"
#include "i2c.h"
#include "wx.h"

STATIC word dev = 0x90;

STATIC byte
	Access_Config    = 0xAC,
	Read_Temperature = 0xAA,
	Start_Convert_T  = 0xEE, /* or 0x51, see below */
	running = FALSE;

void
ds1621_round()
{
	if (running) {
		short temp;

		if (i2c_wr(dev | NOSTOP, &Read_Temperature, 1)
		 && i2c_rd(dev, &temp, sizeof(temp))) {

			temperature_celsius    = temp >> 8;
			temperature_fahrenheit = half_c_to_fahrenheit(temp >> 7);
			have_thermometer = TRUE;
		}
	} else {
		byte config;

		if (i2c_wr(dev | NOSTOP, &Access_Config, 1)
		 && i2c_rd(dev, &config, 1)) {

			if ((config & 0x0C) == 0x0C)
				Start_Convert_T = 0x51;    /* later family */

			if (config & 0x01) {
				config &= ~0x01;           /* continuous, not 1SHOT */

				if (i2c_wr(dev | NOSTOP, &Access_Config, 1)
				 && i2c_wr(NOSTART, &config, 1))
					;
			}
		}
		if (i2c_wr(dev, &Start_Convert_T, 1))
			running = TRUE;
	}
}

